//	zcommacro.h
//

#ifndef	__ZCOM_MACRO_H__
#define	__ZCOM_MACRO_H__

#ifndef	FIELD_OFFSET
#define	FIELD_OFFSET(_struct_name_, _field_name_)	\
	( (uint32_t)&(((_struct_name_ *)0)->_field_name_) )
#endif//!FIELD_OFFSET

#define	FIELD_SIZE(_struct_name_, _field_name_)	\
	( sizeof((((_struct_name_ *)0)->_field_name_)) )

#define	FIELD_INFO(_struct_name_, _field_name_)	\
	FIELD_OFFSET(_struct_name_, _field_name_),	\
	FIELD_SIZE(_struct_name_, _field_name_)

#define	TABLE_COUNT(_table_name_)	\
	(sizeof(_table_name_)/sizeof(_table_name_[0]))

#endif//!__ZCOM_MACRO_H__
