#!/bin/bash

echo "start zcomlog..."
insmod zcommisc.o
insmod nethook.o

echo "loading csr & ethernet drivers..."
insmod csr.o
insmod ixp425_eth.o

echo "Mounting ramd for firmware upgrade...."
mount -n -t ramfs none /mnt/ramd -o maxsize=6000
mkdir -p /mnt/jffs2/igateway/config

# enable it for loopback messages
ifconfig lo   127.0.0.1    netmask 255.0.0.0

#wait for ixp425_eth.o ready
insmod igateway.o
sleep 2

ddns
dnsrd
dhcpc
dhcpd
sntpc
autocelld -D 0xf
sleep 1
configserver
sleep 4
httpd &
wan
wins
vsftpd
sleep 2
cli
